#!/bin/sh

# Copyright 2014, 2019 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

filter="$(REF f)"
order="$(REF o)"

uid="$(timeid)$(randomid)"  # 32 Octets UID, starting with timestamp
card="${uid}.vcf"

mkdir -p "${_DATA}/lock/vcard/"
lockdir="${_DATA}/lock/vcard/${card}/"
lockfile=${lockdir}/${SESSION_ID}

if mkdir "$lockdir"; then
  cat >"$lockfile" <<-EOF
	BEGIN:VCARD
	VERSION:4.0
	N:;;;;
	BDAY:
	TEL:
	EMAIL:
	ADR:
	NOTE:
	UID:${uid}
	END:VCARD
	EOF
  REDIRECT "/cards/?o=${order}&f=${filter}&e=${card}"
else
  SET_COOKIE session message="EDITLOCK"
  REDIRECT "/cards/?o=${order}&f=${filter}"
fi
